#pragma interrupt INTAD callbk_int_ad

/******************************************************************************
  1Ch ADC[h
    de JHL cJZ
    '07 Dec
*******************************************************************************/
#include "incs.h"

extern bit adc_calib_mode;
extern u8 vregs[];

extern bit pwon_wt_sel;


// Vref = 2.8V
//                              F   B   7   3   1   0
u8 const threshold_Co[]       = { 99, 82, 67, 31,  0 }; // batt == 0
u8 const threshold_Co_NAND[]  = { 99, 82, 68, 46, 27 };
u8 const threshold_PSS[]      = { 77, 52, 33, 11,  0 }; // batt == 5
u8 const threshold_PSS_NAND[] = { 82, 55, 42, 30, 27 };
u8 const threshold_IS[]       = { 78, 62, 48, 32,  0 }; // batt == 3, vref = 3.3vAItZbg(1.8V)
u8 const threshold_IS_NAND[]  = { 78, 62, 48, 32, 16 };
//  NAND Av 0 ɂȂ܂B
/*
>>@iAVref=3.3VƂ,AOUT̓dj
>>@@100% 1.95 `          5 F
>>@@ 75% 1.9  ` 1.95V    4 B
>>@@ 50% 1.85 ` 1.9V     3 7
>>@@ 25% 1.8  ` 1.85V    2 3
>>@@@5% 1.75 ` 1.8V     1 1
>>@@@2% 1.7  ` 1.75V    0 0
  */

u16 vBatt_raw;                  // ␳lZO
u16 vBatt;                      // ړςƂ

u8  adc_comp_val;               // ␳lB臒le[uƂɉZ

u16 Vbatt_threshold[5];

u8  battLvl;
u8  battLvl_old;            // 荞݂邽߁Bg񂵂Ă܂


/******************************************************************************
  drddrcʊZ
   dr򉻂ƂAׂɂdrd̍~͋Cɂ܂B
   BOOT[ĥƂ͗܂
   25Hz( = 40msԊu )ŌĂ΂܂
 ******************************************************************************/
void tsk_adc(){
  static u16 vBatt_vals[ 9 ];
  static u8  trigger_counter;
  static u16 geta;
  static u16 vBatt_last_wake;

  static u8  battLvl_hist;
  static u8  battLvl_count;
  u8         battLvl_now;

  static u8  vBatt_th_hys[ 5 ];

  static u8  on_start = 0;
  
#ifdef debug_codes
  if( !pwon_wt_sel ){
#endif
    battLvl_old = battLvl;

    // pX̃mCYAf[^̎荞
    vBatt_vals[ 8 ] = vBatt_vals[ 7 ];
    vBatt_vals[ 7 ] = vBatt_vals[ 6 ];
    vBatt_vals[ 6 ] = vBatt_vals[ 5 ];
    vBatt_vals[ 5 ] = vBatt_vals[ 4 ];
    vBatt_vals[ 4 ] = vBatt_vals[ 3 ];
    vBatt_vals[ 3 ] = vBatt_vals[ 2 ];
    vBatt_vals[ 2 ] = vBatt_vals[ 1 ];
    if( ( ( vBatt_vals[ 0 ] << 1 ) < (  vBatt_vals[ 1 ] + vBatt_raw + 5 ) )
        && ( ( vBatt_vals[ 0 ] << 1 ) > (  vBatt_vals[ 1 ] + vBatt_raw - 5 ) ) ){
      vBatt_vals[ 1 ] = vBatt_vals[ 0 ];
    }else{
      vBatt_vals[ 1 ] = ( ( vBatt_vals[ 0 ] + vBatt_raw ) >> 1 );
    }
    vBatt_vals[ 0 ] = vBatt_raw;
    vBatt = ( ( vBatt_vals[ 8 ] + vBatt_vals[ 7 ] + vBatt_vals[ 6 ] + vBatt_vals[ 5 ]
                + vBatt_vals[ 4 ] + vBatt_vals[ 3 ] + vBatt_vals[ 2 ] + vBatt_vals[ 1 ] ) >> 3 );
    
    // X[v́AQ^ς
    if( PM_SLP == 0 ){
      trigger_counter = 0;
      geta = 0;
    }else{
      trigger_counter++;
      if( trigger_counter == 1 ){
        ;  // JE^̒K킹ł
      }else if( trigger_counter == 2 ){
        vBatt_last_wake = vBatt_vals[ 8 ];
        if( vBatt_last_wake > vBatt_vals[ 7 ] ) vBatt_last_wake = vBatt_vals[ 7 ];
        if( vBatt_last_wake > vBatt_vals[ 6 ] ) vBatt_last_wake = vBatt_vals[ 6 ];
        if( vBatt_last_wake > vBatt_vals[ 5 ] ) vBatt_last_wake = vBatt_vals[ 5 ];
        if( vBatt_last_wake > vBatt_vals[ 4 ] ) vBatt_last_wake = vBatt_vals[ 4 ];
        if( vBatt_last_wake > vBatt_vals[ 3 ] ) vBatt_last_wake = vBatt_vals[ 3 ];
        if( vBatt_last_wake > vBatt_vals[ 2 ] ) vBatt_last_wake = vBatt_vals[ 2 ];
        if( vBatt_last_wake > vBatt_vals[ 1 ] ) vBatt_last_wake = vBatt_vals[ 1 ];
      }else if( trigger_counter < 127 ){
        geta = vBatt - vBatt_last_wake;
        if( geta > 0x8000 ){
          geta = 0;
        }
      }else{
        trigger_counter--;
      }
    }

    if(       ( vBatt - geta ) > Vbatt_threshold[ 0 ] ){ battLvl_now = 0x05;
    }else if( ( vBatt - geta ) > Vbatt_threshold[ 1 ] ){ battLvl_now = 0x04;
    }else if( ( vBatt - geta ) > Vbatt_threshold[ 2 ] ){ battLvl_now = 0x03;
    }else if( ( vBatt - geta ) > Vbatt_threshold[ 3 ] ){ battLvl_now = 0x02;
    }else if( ( vBatt - geta ) > Vbatt_threshold[ 4 ] ){ battLvl_now = 0x01;
    }else{                                               battLvl_now = 0x00;
    }

    DBG_IIC_REG_TMP3( (u8)vBatt );
    DBG_IIC_REG_TMP2( battLvl_now );

    if( battLvl_hist != battLvl_now ){
      battLvl_count = 0;
      battLvl_hist = battLvl_now;
    }else{
      ++battLvl_count;
      if( on_start < 30 ){
        // N͓drdo
        on_start++;
        if( battLvl_count > 10 ){ // 񂩓lAłƂAXV
          battLvl_count = 0;
          battLvl = battLvl_now;
        }
      }else{
        // ʏ^]
        if( battLvl_count > 25 ){ // 񂩓lAłƂAXV
          battLvl_count = 0;
          if( n_ac_supp == 0 ){   // A_v^̗Lňʍs
            // A_v^̗L
            if( battLvl_now > battLvl ){
              battLvl++;
            }
            if( ( battLvl_now != battLvl )
                && ( battLvl_now == 0x00 ) ) {  // ^C~OAA_v^ɂւ炸batt-empty
              battLvl = 0;
            }
          }else{
            // A_v^Ȃ
            if( battLvl_now < battLvl ){
              battLvl--;
            }
          }
        }
      }
    }
#ifdef debug_codes
  }
#endif
  switch( battLvl ){            // }CRx
  case( 2 ): vregs[ REG_INT_ADRS_POWER_INFO ] = 0x03; break;
  case( 3 ): vregs[ REG_INT_ADRS_POWER_INFO ] = 0x07; break;
  case( 4 ): vregs[ REG_INT_ADRS_POWER_INFO ] = 0x0B; break;
  case( 5 ): vregs[ REG_INT_ADRS_POWER_INFO ] = 0x0F; break;
  case( 0 ): vregs[ REG_INT_ADRS_POWER_INFO ] = 0x00; break;
  default:   vregs[ REG_INT_ADRS_POWER_INFO ] = 0x01; break;
  }
  
#ifdef debug_saito_special
  GPIO_dir = 0;
  GPIO_dat = (bit)( battLvl & 0x01 );
#endif
  
  chk_obs_pmic_batt_low();      // NTRAdrcʌʒm
#ifdef debug_codes
  if( !pwon_wt_sel ){
    chk_irq0_batt();            // drcʌ荞
  }
#else
  chk_irq0_batt();
#endif
  ADC_Start();
}



/******************************************************************************
  NTR̈ꕔ̃\tgAPMIC battery_low rbgĂ̂ŃZbgĂ
 ******************************************************************************/
void chk_obs_pmic_batt_low(){
  // Ă̂Œʒm
  if( ( 0x02 < battLvl_old )
      && ( battLvl <= 0x02 ) ){
    iic2m_write_data( IIC_SLV_ADDR_PMIC, 0x02, 0x10 ); // LEDԑ
  }
  // Ă̂ŕA
  if( ( battLvl_old <= 0x03 )
      && ( 0x03 < battLvl ) ){
    iic2m_write_data( IIC_SLV_ADDR_PMIC, 0x02, 0x00 ); // LEDΑ
  }
}



/******************************************************************************
  drĂ荞݂
 ******************************************************************************/
void chk_irq0_batt(){
  static u8 irq_hist = 0;

  // low荞
  if( ( battLvl == 0x01 )
      && ( irq_hist == 0 ) ){
    irq_hist = 0x02;
    vregs[ REG_INT_ADRS_IRQ ] |= 0x20;
    if( is_TWL ){
//      DI();
      n_irq_ast;
      n_irq_ngt;
//      EI();
    }
  }

  if( with_NAND ){
    // empty荞
    // dȍ̎dlɂAc1щz0ɂȂ邱Ƃ͂Ȃ...͂B
    if( battLvl == 0x00 ){
      if( irq_hist == 0x00 ){                // ˑR emptyɂȂH
        irq_hist = 0x03;
        vregs[ REG_INT_ADRS_IRQ ] |= 0x30;   // ȂAĂ
        if( is_TWL ){
//          DI();
          n_irq_ast;
          n_irq_ngt;
//          EI();
        }
      }else if( irq_hist == 0x02 ){       // ȑOLow荞݂
        irq_hist = 0x03;
        vregs[ REG_INT_ADRS_IRQ ] |= 0x10;   // 荞݂|܂Ȃ悤
        if( is_TWL ){
//        DI();
          n_irq_ast;
          n_irq_ngt;
//        EI();
        }
      }
    }
  }

  // drĂtOĂ܂
  if( battLvl >= 0x01 ){                // lowȏȂ
//    DI();
    vregs[ REG_INT_ADRS_IRQ ] &= ~0x10; // emptyȂƂ
//    EI();
    irq_hist &= ~0x01;
  }

  if( battLvl >= 0x02 ){                // lowȂ
//    DI();
    vregs[ REG_INT_ADRS_IRQ ] &= ~0x30; // lowemptyȂƂ
//    EI();
    irq_hist &= ~0x03;
  }
}




/******************************************************************************
  dr/[hؑւ臒lZbg
 ******************************************************************************/
void set_batt_th(){
  u8 *p_tbl;
  u8 tmp;

  if( with_NAND ){
    if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_CO ){       // Co  (0b000)
      p_tbl = &threshold_Co_NAND[0];
    }else if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_IS ){ // IS  (0b011)
      p_tbl = &threshold_IS_NAND[0];
    }else{                                                  // PSS (0b111)
      p_tbl = &threshold_PSS_NAND[0];
    }
  }else{ // NAND یȂ
    if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_CO ){
      p_tbl = &threshold_Co[0];
    }else if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_IS ){
      p_tbl = &threshold_IS[0];
      IS_led_cam = 0;                 // ԔΉ
      IS_led_cam_mode = 0;            // ԔΉ
    }else{
      p_tbl = &threshold_PSS[0];
    }
  }
  for( tmp = 0; tmp != 5; tmp++ ){
    Vbatt_threshold[ tmp ] = 512 + adc_comp_val + *p_tbl;
    p_tbl++;
  }
}



/******************************************************************************
  VoffL̑

  4msԊuŎ荞݁AKvȂƂ8̕ώ܂B
        ____________________________
 /RESET                             ______
        ---------_________|30ms |
 VDET+                  +-----____
                          |         _____ 
 ADCTvO   ***||||||||****
                      @̕ 8̕ςƂ
 ******************************************************************************/
void tsk_adc_calib(){
         u8  adc_avg;
  static u8  count_for_IS = 0;
  static u8  state = 0;
  static u8  adc_raw_data_B[8], adc_raw_data_A[4];  // ϑΏۂB,ΏۊOA
  static u16 adc_sum8 = 0;
  static u8  adc_rec_val = 0;
  static u8  count = 0;
  
  switch( state ){
  case( 0 ):
    // 
    IIC0_Stop();
    TMH0_Stop();  // pow_R
    TMH1_Stop();  // pow_B
    TM50_Stop();  // wifi
    P1.7 = 1; // Y
    P1.5 = 1; // R
    P1.6 = 1; // B
    CR51 = 125 - 1 ; // T = 4ms
    iic2m_write_data( IIC_SLV_ADDR_PMIC, 0x02, (u8*)0x00 );
    state = 1;
    break;
  case( 1 ):
    // X[v҂BԔȂ҂Ȃ
//    if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_IS ){
//      state = 2;
//    }else{
    {
      if( PM_SLP == 1 ){
        P1.7 = 0; // Y
        vregs[ REG_INT_ADRS_POWER_SAVE ] = 0x07;
        PM_set_VRSET();
        state = 2;
      }
    }
    break;
    
  case( 2 ):
    // vBatt_raw ͕␳ĂȂ f ̒lł
    // l悪܂Ă̂ŁA8rbg݂ȂB
    // ]T݂ 3.1`3.5Vł݂ĂA567`640Ȃ̂ŁA512āA55`128ł܂܂]T
    // ȏゾ擾sij
    if( ( vBatt_raw > ( 512 + 0x60 ) ) || ( vBatt_raw < ( 512 + 0x40 ) ) ){
      break;
    }
    // ܂AvZΏۂ̃obt@8𖄂߂
    adc_raw_data_B[ count ] = (u8)( vBatt_raw & 0x00FF ); // }XNȂBMĂB
    adc_sum8 += ( vBatt_raw & 0x00FF );
    if( count == 7 ){           // 8񂽂߂
      count = 0;
      state = 3;
    }else{
      count++;
    }
    break;
    
  case( 3 ):
    // ɁAfBCp̃obt@4𖄂߂
    adc_raw_data_A[ count ] = (u8)( vBatt_raw & 0x00FF );
    if( count == 3 ){           // 4񂽂߂
      P1.6 = 0; // B
      count = 0;
      state = 4;
    }else{
      count++;
    }
    break;
    
  default:
    if( n_sys_reset != 0 ){ // Zbĝ͂ǂ炩Ƃƌ돑ݖh~
                            // ^C~OȂAd̕ĂԂ񏑂݊Ȃ 

      adc_avg = (u8)( adc_sum8 / 8 );
      // ȂƁA[ȃVtg͊ZɂȂi25clkjVtg葁ƌƂB
      // ISΉ
      if( vregs[ REG_INT_ADRS_BATT_INFO ] == BATT_IS ){
        adc_avg -= ( 9 + 16 );         // Lu[V1.8V @ ref = 3.3 1.65VɊZ
        if( flash_write( DAT_ADC_COMP, &adc_avg ) == 0 ){  // ڗȂǁAŏ
          mcu_reset;
        }
      }
      // KvȂL^
      if( adc_rec_val != adc_avg ){
        if( flash_write( DAT_ADC_COMP, &adc_avg ) == 0 ){
          P1.5 = 0; // R
          P1.6 = 1; // B
          adc_rec_val = adc_avg;
          P1.6 = 0; // B
          P1.5 = 1; // R
        }
      }
    
      // Oobt@XV
      if( ( vBatt_raw & 0x00FF ) < 128 ){
        adc_sum8 -= adc_raw_data_B[ count ];                 // vÂ̂
        adc_raw_data_B[ count ] = adc_raw_data_A[ ( count & 0x03 ) ];   // vobt@[
        adc_sum8 += adc_raw_data_B[ count ];                 // v  V̂𑫂
        adc_raw_data_A[ ( count & 0x03 ) ] = (u8)( vBatt_raw & 0x00FF );  // vobt@XV
                                                             // ܂肤ꂵȂ..
        count = ( count < 7 )? count + 1: 0; // ȏW
      }
    }
  }
  ADC_Start();
}



//****************************************************************************
__interrupt void callbk_int_ad(){
  EI();
  vBatt_raw = ( ADCR >> 6 ); // Eɂ߂Ă܂...ȂŁB
  ADC_Stop();
}



//****************************************************************************
void ADC_Init(){
  ADPC = PORT_ADPC_3DIO;        // /IRQ_0 ͐êقvAbvĂ
  ADM  = 0x90;                  // fAD = fPRS/6, wait:2`13ClkSys
  ADS  = 0x03;
}



void ADC_Start(){
    ADM.0 = 1;                  // ADCE
    NOP();                      // 1usȂႢȂ
    NOP();                      // nop : 2clkłB
    NOP();
    NOP();
    ADM.7 = 1;                  // ADCS
    MK1L.0 = 0;                 // ADC荞݃}XN
}



void ADC_Stop(){
    MK1L.0 = 1;                 // ADMK = 1;
    ADM.7 = 0;                  // ADCS
    ADM.0 = 0;                  // ADCE
}

