#pragma section @@CODE c_flash
#pragma section @@BITS c_f_bits AT 0xFE88
#pragma section @@DATA c_f_data AT 0xFE90

#pragma HALT
#pragma NOP

#include "macrodriver.h"
#include "user_define.h"
#include "jhl_defs.h"
#include "I2C_selfprog.h"
#include "SelfLib.h"

#include "user_define.h"
#include "Timer.h"

extern sreg UCHAR EntryRAM[];


bit self_prog_mode;

u8 writeBuffer[16];
struct stWordAddress self_prog_settings;




/*****************************************************************************
  I2C玩ȏ
  ͈͂ 0x0000 - 0x1FFF܂ŁB
  I2CقŎgĂ̂ŁAtOȂǂŔłĂB
  ͓dēKvłB
  }CR͒~܂B
 *****************************************************************************/
void self_programming(){
  u8 status;
  
  self_write_init();

  led_wifi = 1;
  FlashStart();
  FlashEnv( EntryRAM );

  if( self_write_eraseall() != 0 ){
    led_R_on;
    FlashEnd();
    LREL0 = 1;
    while(1){}
  }
  led_wifi = 0;

  /// tbV̏ ///
  self_prog_settings.WriteBank = 0;

  //// es̏ ////
  while( 1 ){
    led_wifi = 1;
    status = i2c_firm_rcv_line();
    if( status != 0 ){
      led_G_on;
      FlashEnd();
      LREL0 = 1;
      LSRSTOP = 0;
      WDTE = 0x4A;              // Zbg
      while(1){}
    }
    led_wifi = 0;

    status = write_firm_line();
    if( ( status & 0x80 ) != 0 ){
      // tbVُ풆f
      FlashEnd();
      LREL0 = 1;
      while(1){}
    }
    led_wifi = 0;
  }
  FlashEnd();
  WDTE = 0x01;                  // Zbg
  while(1){}
}



/*****************************************************************************
 
 *****************************************************************************/
static void self_write_init(){
//  SPIE0 = 1;
  WTIM0 = 1;                    // EFCgRfBVBij

  // B //
  TMHE1 = 0;		/* stop TimerH0 */
  TOEN1 = 0;		/* disable output */
  led_G_pwm;
  
  // R //
  TMHE0 = 0;		/* stop TimerH0 */
  TOEN0 = 0;		/* disable output */
  led_R_pwm;

  // Y //
  TCE50 = 0;                    /* TM50 counter disable */
  TOE50 = 0;                    /* output disabled */
  // TM50_Stop();  // LED_Wifi gႾ߁I
  led_wifi = 1;

  LSRSTOP = 1;                  // WDT~
  
  DI();
  MK0 = 0xFFFF;
  MK1 = 0xFFFF;
  EI();
}



/*****************************************************************************
 ݑΏۂ̕
 *****************************************************************************/
static u8 self_write_eraseall(){
  u8 flash_status = 0;
  u8 temp;
  
  flash_we = 1;
  if( CheckFLMD() != 0 ){
    return( 128 + 1 );
  }

  for( temp = 0; temp != (u8)( ( 0x2800 & 0xFC00 ) >> 10 ); temp++ ){
    if( FlashBlockBlankCheck( 0, temp ) == 0x1B ){
      flash_status |= FlashBlockErase( 0, temp );
    }
  }
  if( flash_status != 0 ){
    return( 128 + 2 );
  }
}



/*****************************************************************************
 sMBf[^Ȃ0xFFŃpfBO悤ɂȂĂ邯ǁA
  f[^ƂĂ̂Ŗ{sv
 *****************************************************************************/
static u8 i2c_firm_rcv_line(){
  u8 rec_length;
  u8 data_counter;
  u8 temp;

  // ':' R[h}[N
  do{
    IICIF0 = 0;
    WREL0 = 1;
    while( ( IICIF0 == 0 ) && ( SPD0 == 0 ) ){ ; }
    if( SPD0 == 1 ){
      return( 1 );              // IB
    }
  }while( IIC0 != ':' );        // ^CAEgƂȂŉi[v

  // R[h
  rec_length = rcvHex2bin();

  // AhX
  temp = rcvHex2bin(); // 
  self_prog_settings.WriteAddress = (u8*)( ( (u16)temp << 8 ) + rcvHex2bin() );  // 

  // "00" iR[h^Cvj
  if( rcvHex2bin() == 01 ){
    return( 2 );                // IB
  }

  // f[^
  for( data_counter = 0; data_counter < rec_length; data_counter++){
    writeBuffer[ data_counter ] = rcvHex2bin();
  }

  // Tiǂݎ̂āj
  rcvHex2bin();
  // sR[h \r\n ͂ł͌Ȃ

  // 0xFFŎcpfBO
  while( data_counter < 16 ){
    writeBuffer[ data_counter ] = 0xFF;
    data_counter++;
  }
  return( 0 );
}


/*****************************************************************************
  4[h16oCgB
 *****************************************************************************/
static u8 write_firm_line(){
  // C^[Abvf[gṔA
  // 0x0000 - 0x1FFF u[g{̂𓮂R[h
  // 0x2000 - 0x27FF ȏR[h
  // 0x2800 -        󂫁B
  // 
  // C^[Abvf[gQ`́A
  // 0x0000 - 0x1FFF u[g{̂𓮂R[h
  // 0x2000 - 0x27FF i󂫁j
  // 0x2800 -        ȏR[h
  // ł
  if( self_prog_settings.WriteAddress >= (u8*)0x2800 ){
    // EEPG~[VŏȂ͈
    return( 2 );
  }else{
    // ͈
    led_R_on;
    if( FlashWordWrite( &self_prog_settings, 4, writeBuffer ) != 0 ){
      return( 128 + 64 + 1 );
    }
    led_G_on;
    if( FlashBlockVerify( 0, (u8)( ( (u16)(self_prog_settings.WriteAddress) & 0xFC00 ) >> 10 ) ) != 0 ){
      // Cg gC
      led_R_pwm;
      if( FlashWordWrite( &self_prog_settings, 4, writeBuffer ) != 0 ){
        return( 128 + 64 + 2 );
      }
      if( FlashBlockVerify( 0, (u8)( ( (u16)(self_prog_settings.WriteAddress) & 0xFC000 ) >> 10 ) ) != 0 ){
        // dאffG[
        return( 128 + 64 + 3 );
      }
    }
    // 1s܂B
    led_G_pwm;
    led_R_pwm;
  }
  return( 0 );
}



/*****************************************************************************
  QoCg̃wLTMăoCiԂB
  0x31 0x33  0x13
  G[ƂĂȂłB
  |[OłB
 *****************************************************************************/
static u8 rcvHex2bin(){
  u8 dat;
  u8 temp;
  
  IICIF0 = 0;
  WREL0 = 1;
  while( IICIF0 == 0 ){ ; }
  temp = IIC0;
  if( ( '0' <= temp ) && ( temp <= '9' ) ){
    dat = ( temp - '0' );
  }else if( ( 'A' <= temp ) && ( temp <= 'Z' ) ){
    dat = ( temp - 'A' + 10 );
  }else if( ( 'a' <= temp ) && ( temp <= 'z' ) ){
    dat = ( temp - 'a' + 10 );
  }
  dat <<= 4;

  IICIF0 = 0;
  WREL0 = 1;
  while( IICIF0 == 0 ){ ; }
  temp = IIC0;
  if( ( '0' <= temp ) && ( temp <= '9' ) ){
    dat |= ( temp - '0' );
  }else if( ( 'A' <= temp ) && ( temp <= 'Z' ) ){
    dat |= ( temp - 'A' + 10 );
  }else if( ( 'a' <= temp ) && ( temp <= 'z' ) ){
    dat |= ( temp - 'a' + 10 );
  }

  return( dat );
}

