#ifndef _MDPORT_
#define _MDPORT_

/* Port mode register(PMn.0 to 7) */
#define PMn0_NOT_USE		0x01
#define PMn1_NOT_USE		0x02
#define PMn2_NOT_USE		0x04
#define PMn3_NOT_USE		0x08
#define PMn4_NOT_USE		0x10
#define PMn5_NOT_USE		0x20
#define PMn6_NOT_USE		0x40
#define PMn7_NOT_USE		0x80

#define PMn0_MODE_INPUT		0x01
#define PMn0_MODE_OUTPUT	0x00
#define PMn1_MODE_INPUT		0x02
#define PMn1_MODE_OUTPUT	0x00
#define PMn2_MODE_INPUT		0x04
#define PMn2_MODE_OUTPUT	0x00
#define PMn3_MODE_INPUT		0x08
#define PMn3_MODE_OUTPUT	0x00
#define PMn4_MODE_INPUT		0x10
#define PMn4_MODE_OUTPUT	0x00
#define PMn5_MODE_INPUT		0x20
#define PMn5_MODE_OUTPUT	0x00
#define PMn6_MODE_INPUT		0x40
#define PMn6_MODE_OUTPUT	0x00
#define PMn7_MODE_INPUT		0x80
#define PMn7_MODE_OUTPUT	0x00

#define PMn0_CHANGE_OUTPUT	0xFE
#define PMn1_CHANGE_OUTPUT	0xFD
#define PMn2_CHANGE_OUTPUT	0xFB
#define PMn3_CHANGE_OUTPUT	0xF7
#define PMn4_CHANGE_OUTPUT	0xEF
#define PMn5_CHANGE_OUTPUT	0xDF
#define PMn6_CHANGE_OUTPUT	0xBF
#define PMn7_CHANGE_OUTPUT	0x7F

/* ADPC define */
#define PORT_ADPC_0DIO		0
#define PORT_ADPC_1DIO		1
#define PORT_ADPC_2DIO		2
#define PORT_ADPC_3DIO		3
#define PORT_ADPC_4DIO		4

/* Port register(Pn.0 to 7) */
#define Pn0_OUTPUT_0		0x00
#define Pn0_OUTPUT_1		0x01
#define Pn1_OUTPUT_0		0x00
#define Pn1_OUTPUT_1		0x02
#define Pn2_OUTPUT_0		0x00
#define Pn2_OUTPUT_1		0x04
#define Pn3_OUTPUT_0		0x00
#define Pn3_OUTPUT_1		0x08
#define Pn4_OUTPUT_0		0x00
#define Pn4_OUTPUT_1		0x10
#define Pn5_OUTPUT_0		0x00
#define Pn5_OUTPUT_1		0x20
#define Pn6_OUTPUT_0		0x00
#define Pn6_OUTPUT_1		0x40
#define Pn7_OUTPUT_0		0x00
#define Pn7_OUTPUT_1		0x80

/* Pull-up resistor option register(PUn.0 to 7) */
#define PUn0_PULLUP_OFF		0x00
#define PUn0_PULLUP_ON		0x01
#define PUn1_PULLUP_OFF		0x00
#define PUn1_PULLUP_ON		0x02
#define PUn2_PULLUP_OFF		0x00
#define PUn2_PULLUP_ON		0x04
#define PUn3_PULLUP_OFF		0x00
#define PUn3_PULLUP_ON		0x08
#define PUn4_PULLUP_OFF		0x00
#define PUn4_PULLUP_ON		0x10
#define PUn5_PULLUP_OFF		0x00
#define PUn5_PULLUP_ON		0x20
#define PUn6_PULLUP_OFF		0x00
#define PUn6_PULLUP_ON		0x40
#define PUn7_PULLUP_OFF		0x00
#define PUn7_PULLUP_ON		0x80

#define	PM0_DEFAULT		0xFC
#define	PM2_DEFAULT		0xF0
#define	PM3_DEFAULT		0xF0
#define	PM6_DEFAULT		0xFC
#define	PM12_DEFAULT		0xF8



void PORT_Init ( void );

void callbk_int_wifiTx();

#endif
