#include "incs.h"
#include "eeelib.h"
#include "eepe.h"



extern u8 vregs[];
extern u8 adc_comp_val;

bit       EEPemu;



/*****************************************************************************
@
 ****************************************************************************/
void flash_init(){
  if( ( iic2m_read_byte( IIC_SLV_ADDR_DCP, 1 ) & 0x80 ) == 0 ){  // == isl95810
//  if( ( iic2m_read_byte( IIC_SLV_ADDR_DCP, 1 ) & 0x80 ) != 0 ){  // == isl95811
    EEPemu = 1;
    eepe_init();
  }else{
    EEPemu = 0;
  }
}



/*****************************************************************************
@
 ****************************************************************************/
void restore_params(){
  u8 temp,temp2;
  u8 eep_status;

  // ADC␳p[^A //
  eep_status = flash_read( DAT_ADC_COMP, &temp );
  if( EEPemu == 0 ){
    // ISL95811ŁA݂ɎsĂm 0xFF Ȃ̂
    flash_read( DAT_ADC_COMP + 1 , &temp2 );
    if( temp2 < temp ){ temp = temp2; }
    flash_read( DAT_ADC_COMP + 2 , &temp2 );
    if( temp2 < temp ){ temp = temp2; }
    flash_read( DAT_ADC_COMP + 3 , &temp2 );
    if( temp2 < temp ){ temp = temp2; }
  }
  if( eep_status == EEE_NORMAL ){
    adc_comp_val = temp;
    vregs[ REG_INT_ADRS_ADC_CALIB_STATUS ] = 1;
  }else{                        // G[
    adc_comp_val = 0x50;          // 512ɂ𑫂B]T 3.40V Ƃ
    vregs[ REG_INT_ADRS_ADC_CALIB_STATUS ] = 0xE0;
  }
  vregs[ REG_INT_ADRS_ADC_CALIB_VALUE ] = adc_comp_val;
  DBG_IIC_REG_TMP1( adc_comp_val );

  // obNCgPxA //
  eep_status = flash_read( DAT_BL_BRIGHT, &temp );
  if( ( eep_status == EEE_NORMAL ) && 
      ( temp <= BL_IND_MAX ) ){
    vregs[ REG_INT_ADRS_BL ] = temp;
  }else{
    vregs[ REG_INT_ADRS_BL ] = 3;  // TWLl
  }
//  rsv_set_BL = 1;                // svB/reset̉҂āApmic_init()B
}


/*****************************************************************************
@Ŏgp
 ****************************************************************************/

// ňxgCs܂B
// ߂G[Ԃ܂B
// ԂlFG[R[h
u8 flash_write( u8 adrs, u8* dat ){
  static u8 EEPe_counter = 0;
  u8 status;

  if( EEPemu == 1 ){            // tbVEEPROMG~[V

    // O
    DI();
    IIC0_Stop();
    TM51_Stop();
    ADC_Stop();
    flash_we = 1;

    status = ucEEPROMWriteEx_A( adrs, dat );
    if( status != 0x00 ){       // 񂾂gC
      flash_erase();
      flash_block_change();
      status = ucEEPROMWriteEx_A( adrs, dat );
    }

    // ㏈
    flash_we = 0;
    IIC0_SlaveReceiveStart();
    TM51_Start();
    ADC_Start();
    EI();
    return( status );  // ݎsƂ
  }else{
    // 95811Bm[`FbNȂ̂łB
    if( adrs == DAT_ADC_COMP ){
      EEPe_counter &= 0x03;
      return( iic2m_write_data( IIC_SLV_ADDR_DCP, adrs + 2 + EEPe_counter++, *dat ) ); // nakƂB
    }else{
      return( iic2m_write_data( IIC_SLV_ADDR_DCP, adrs + 2, *dat ) );
    }
  }
}


// ԂlFG[R[h
u8   flash_read( u8 adrs, u8* dat ){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    return( ucEEPROMReadEx_A( adrs, dat ) );
  }else{
    // 95811Bm[`FbN
    *dat = iic2m_read_byte( IIC_SLV_ADDR_DCP, adrs + 2 );
    return 0;
  }
}


// ԂlFG[R[h
u8   flash_erase(){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    return( ucEEPROMEraseEx_A() );
  }else{
    return( 0 );
    // nothing to do
  }
}


// ԂlFG[R[h
u8   flash_block_change(){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    return( ucEEPROMChangeEx_A() );
  }else{
    // nothing to do
    return 0;
  }
}


void flash_enable(){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    DI();
    IIC0_Stop();
    TM51_Stop();
    ADC_Stop();
    flash_we = 1;
  }else{
    // nothing to do
  }
}


void flash_disable(){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    flash_we = 0;
    IIC0_SlaveReceiveStart();
    TM51_Start();
    ADC_Start();
    EI();
  }else{
    // nothing to do
  }
}


// gp
u8 self_free_space(){
  if( EEPemu == 1 ){            // tbVEEPROMG~[V
    return( ucEEPROMGetRemainEx_A() );
  }else{
    return( 0xFF );
  }
}
